Subject: Re: [PATCH v1 net] tcp/dccp: Don't use timer_pending() in reqsk_queue_unlink().

From: Martin KaFai Lau <[email-masked]>
Date: Fri, 11 Oct 2024 21:01:59 -0700

On 10/8/24 7:42 AM, Kuniyuki Iwashima wrote:
> From: Eric Dumazet <[email-masked]>
> Date: Tue, 8 Oct 2024 16:28:53 +0200
>> On Tue, Oct 8, 2024 at 4:21 PM Kuniyuki Iwashima <[email-masked]> wrote:
>>>
>>> From: Eric Dumazet <[email-masked]>
>>> Date: Tue, 8 Oct 2024 11:54:21 +0200
>>>> On Tue, Oct 8, 2024 at 1:53 AM Kuniyuki Iwashima <[email-masked]> wrote:
>>>>>
>>>>> From: Jakub Kicinski <[email-masked]>
>>>>> Date: Mon, 7 Oct 2024 16:26:10 -0700
>>>>>> On Mon, 7 Oct 2024 07:15:57 -0700 Kuniyuki Iwashima wrote:
>>>>>>> Martin KaFai Lau reported use-after-free [0] in reqsk_timer_handler().
>>>>>>>
>>>>>>>    """
>>>>>>>    We are seeing a use-after-free from a bpf prog attached to
>>>>>>>    trace_tcp_retransmit_synack. The program passes the req->sk to the
>>>>>>>    bpf_sk_storage_get_tracing kernel helper which does check for null
>>>>>>>    before using it.
>>>>>>>    """
>>>>>>
>>>>>> I think this crashes a bunch of selftests, example:
>>>>>>
>>>>>> https://netdev-3.bots.linux.dev/vmksft-nf-dbg/results/805581/8-nft-queue-sh/stderr
>>>>>
>>>>> Oops, sorry, I copy-and-pasted __inet_csk_reqsk_queue_drop()
>>>>> for different reqsk.  I'll squash the diff below.
>>>>>
>>>>> ---8<---
>>>>> diff --git a/net/ipv4/inet_connection_sock.c b/net/ipv4/inet_connection_sock.c
>>>>> index 36f03d51356e..433c80dc57d5 100644
>>>>> --- a/net/ipv4/inet_connection_sock.c
>>>>> +++ b/net/ipv4/inet_connection_sock.c
>>>>> @@ -1188,7 +1190,7 @@ static void reqsk_timer_handler(struct timer_list *t)
>>>>>          }
>>>>>
>>>>>   drop:
>>>>> -       __inet_csk_reqsk_queue_drop(sk_listener, nreq, true);
>>>>> +       __inet_csk_reqsk_queue_drop(sk_listener, oreq, true);
>>>>>          reqsk_put(req);
>>>>>   }
>>>>>
>>>>> ---8<---
>>>>>
>>>>> Thanks!
>>>>
>>>> Just to clarify. In the old times rsk_timer was pinned, right ?
>>>>
>>>> 83fccfc3940c4 ("inet: fix potential deadlock in reqsk_queue_unlink()")
>>>> was fine I think.
>>>>
>>>> So the bug was added recently ?
>>>>
>>>> Can we give a precise Fixes: tag ?
>>>
>>> TIMER_PINNED was used in reqsk_queue_hash_req() in v6.4 mentioned
>>> by Martin and still used in the latest net-next.
>>>
>>> $ git blame -L:reqsk_queue_hash_req net/ipv4/inet_connection_sock.c v6.4
>>> 079096f103fac (Eric Dumazet             2015-10-02 11:43:32 -0700 1095) static void reqsk_queue_hash_req(struct request_sock *req,
>>> 079096f103fac (Eric Dumazet             2015-10-02 11:43:32 -0700 1096)                                  unsigned long timeout)
>>> fa76ce7328b28 (Eric Dumazet             2015-03-19 19:04:20 -0700 1097) {
>>> 59f379f9046a9 (Kees Cook                2017-10-16 17:29:19 -0700 1098)         timer_setup(&req->rsk_timer, reqsk_timer_handler, TIMER_PINNED);
>>>
>>> Maybe the connection was localhost, or unlikely but RPS was
>>> configured after SYN+ACK, or setup like ff46e3b44219 was used ??

I don't know what exactly caused the ack to be handled on a different CPU. We 
have a recent packet steering test, so it could be caused by this test 
adjusting the steering config.

>>
>> I do not really understand the issue.
>> How a sk can be 'closed' with outstanding request sock ?
>> They hold a refcount on the listener.
> 
> My understanding is
> 
> 1. inet_csk_complete_hashdance() calls inet_csk_reqsk_queue_drop(),
>     but del_timer_sync() is missed
> 
> 2. reqsk timer is executed and scheduled again
> 
> 3. req->sk is accept()ed, but inet_csk_accept() does not clear
>     req->sk for non-TFO sockets, and reqsk_put() decrements one
>     refcnt, but still reqsk timer has another one
> 
> 4. sk is close()d
> 
> 5. reqsk timer is executed again, and BPF touches req->sk

The above is also what I think is happening.
The kernel reqsk_timer_handler() is not using req->sk, so it has not been an issue.

> 
> reqsk timer will run for 63s by default, so I think it's possible
> that sk is close()d earlier than the timer expiration.
>